% cl_ct.m
% 
% Cruisebuilder/Cruisetrack
%
% Usage: cl_ct
% Click on help buttons for tips.
% Version 1.7, 11 June 2008, Chris Linder
%

guifontsize=8;

%*****Set defaults*****
format compact;
f1=figure;
clf;
set(f1,'Position',[30 30 490 460]);
set(f1,'Name','Cruisetrack Version 1.7');
screenstats = get(gcf,'Position');
cl_ctini;
if exist(ctdirectory)==7
   cd(ctdirectory);
else
   ctdirectory=pwd;
end;
more off;


%*****Pathframe*****
frame_path = uicontrol(f1,...
  'Style','frame',...
  'Position',[10 420 230 30]);

%*****Path*****
text_pathfil = uicontrol(f1,...
  'Style','text',...
  'Fontsize',guifontsize,....
  'String','Path:',...
  'HorizontalAlignment','Left',...
  'Position',[20 425 120 15]);
en_pathfil = uicontrol(f1,...
  'Style','edit',...
  'Fontsize',guifontsize,....
  'String',ctdirectory,...
  'Position',[55 425 175 20],...
  'CallBack',[...
    'ctdirectory = get(en_pathfil,''String'');,',...
    'if exist(ctdirectory)==7 cd(ctdirectory); else ,',...
    'msgbox(''Directory not found.  Please reenter.'',''Error'',''Error'');,',...
    'ctdirectory=pwd; set(en_pathfil,''String'',pwd); end;']);

%*****Clear figures button commands*****
pb_clearfigs = uicontrol(f1,...
  'Style','push',...
  'Fontsize',guifontsize,....
  'String','Clear figs',...
  'Pos',[250 420 55 30],...
  'CallBack',[...
    '[flag,killfigs] = figflag('''');,',...
    'delete(killfigs);']);

%*****Save defaults button commands*****
pb_savedefaults = uicontrol(f1,...
  'Style','push',...
  'Fontsize',guifontsize,....
  'String','Save defaults',...
  'Pos',[310 420 80 30],...
  'CallBack','cl_ctsave');

%*****About button commands*****
pb_about = uicontrol(f1,...
  'Style','push',...
  'Fontsize',guifontsize,....
  'String','About',...
  'Pos',[395 420 45 30],...
  'CallBack','cl_ctabt');

%*****Exit button commands*****
pb_exit = uicontrol(f1,...
  'Style','push',...
  'Fontsize',guifontsize,....
  'String','Exit',...
  'Pos',[445 420 35 30],...
  'CallBack','close(f1)');


%*****Common plotting options*****
frame_common = uicontrol(f1,...
  'Style','frame',...
  'Position',[10 200 230 215]);
text_common = uicontrol(f1,...
  'Style','text',...
  'Fontsize',guifontsize,....
  'String','Common plotting options',...
  'HorizontalAlignment','Left',...
  'Position',[20 385 150 20]);
pb_cohelp = uicontrol(f1,...
  'Style','push',...
  'Fontsize',guifontsize,....
  'String','Help',...
  'Pos',[190 390 40 20],...
  'CallBack','cl_ctcohelp');
text_box = uicontrol(f1,...
  'Style','text',...
  'Fontsize',guifontsize,....
  'String','Box:',...
  'HorizontalAlignment','Center',...
  'Position',[20 360 25 20]);
text_minlon = uicontrol(f1,...
  'Style','text',...
  'Fontsize',guifontsize,....
  'String','W',...
  'HorizontalAlignment','Center',...
  'Position',[46 360 20 20]);
en_minlon = uicontrol(f1,...
  'Style','edit',...
  'Fontsize',guifontsize,....
  'String',num2str(minlon),...
  'Position',[66 365 26 20],...
  'CallBack','minlon = str2num(get(en_minlon,''String''));');
text_maxlon = uicontrol(f1,...
  'Style','text',...
  'Fontsize',guifontsize,....
  'String','E',...
  'HorizontalAlignment','Center',...
  'Position',[92 360 20 20]);
en_maxlon = uicontrol(f1,...
  'Style','edit',...
  'Fontsize',guifontsize,....
  'String',num2str(maxlon),...
  'Position',[112 365 26 20],...
  'CallBack','maxlon = str2num(get(en_maxlon,''String''));');
text_minlat = uicontrol(f1,...
  'Style','text',...
  'Fontsize',guifontsize,....
  'String','S',...
  'HorizontalAlignment','Center',...
  'Position',[138 360 20 20]);
en_minlat = uicontrol(f1,...
  'Style','edit',...
  'Fontsize',guifontsize,....
  'String',num2str(minlat),...
  'Position',[158 365 26 20],...
  'CallBack','minlat = str2num(get(en_minlat,''String''));');
text_maxlat = uicontrol(f1,...
  'Style','text',...
  'Fontsize',guifontsize,....
  'String','N',...
  'HorizontalAlignment','Center',...
  'Position',[184 360 20 20]);
en_maxlat = uicontrol(f1,...
  'Style','edit',...
  'Fontsize',guifontsize,....
  'String',num2str(maxlat),...
  'Position',[204 365 26 20],...
  'CallBack','maxlat = str2num(get(en_maxlat,''String''));');
%*****Coastline file*****
cb_cl = uicontrol(f1,...
  'Style','checkbox',...
  'Fontsize',guifontsize,....
  'String','Plot coastline',...
  'Position',[20 340 210 20],...
  'Value',clchoice,...
  'CallBack',[...
    'clchoice = 1;,',...
    'if get(cb_cl,''Value'')==0,',...
      'clchoice = 0;,',...
    'end']);
%*****Bathymetry file*****
cb_bt = uicontrol(f1,...
  'Style','checkbox',...
  'Fontsize',guifontsize,....
  'String','Plot bathymetry contours',...
  'Position',[110 340 210 20],...
  'Value',btchoice,...
  'CallBack',[...
    'btchoice = 1;,',...
    'if get(cb_bt,''Value'')==0,',...
      'btchoice = 0;,',...
    'end']);
text_btcontours = uicontrol(f1,...
  'Style','text',...
  'Fontsize',guifontsize,....
  'String','Contours:',...
  'HorizontalAlignment','Left',...
  'Position',[20 315 70 20]);
en_btcontours = uicontrol(f1,...
  'Style','edit',...
  'Fontsize',guifontsize,....
  'String',num2str(btcontours),...
  'Position',[90 320 140 20],...
  'CallBack','btcontours = str2num(get(en_btcontours,''String''));');
text_btmode = uicontrol(f1,...
  'Style','text',...
  'Fontsize',guifontsize,....
  'String','Datasource:',...
  'HorizontalAlignment','Left',...
  'Position',[20 295 100 20]);
rb_btmode1 = uicontrol(f1,...
  'Style','radio',...
  'Fontsize',guifontsize,....
  'String','2min ETOPO2',...
  'Position',[90 300 140 20],...
  'Value',rb_btmode1,...
  'CallBack',[...
    'set(rb_btmode1,''Value'',1),',...
    'set(rb_btmode2,''Value'',0),',...
    'set(rb_btmode3,''Value'',0),',...
    'btmode = 1;']);
rb_btmode2 = uicontrol(f1,...
  'Style','radio',...
  'Fontsize',guifontsize,....
  'String','5min TerrainBase',...
  'Position',[90 280 140 20],...
  'Value',rb_btmode2,...
  'CallBack',[...
    'set(rb_btmode1,''Value'',0),',...
    'set(rb_btmode2,''Value'',1),',...
    'set(rb_btmode3,''Value'',0),',...
    'btmode = 2;']);
rb_btmode3 = uicontrol(f1,...
  'Style','radio',...
  'Fontsize',guifontsize,....
  'String','File:',...
  'Position',[90 260 60 20],...
  'Value',rb_btmode3,...
  'CallBack',[...
    'set(rb_btmode1,''Value'',0),',...
    'set(rb_btmode2,''Value'',0),',...
    'set(rb_btmode3,''Value'',1),',...
    'btmode = 3;']);
en_btfile = uicontrol(f1,...
  'Style','edit',...
  'Fontsize',guifontsize,....
  'String',btfile,...
  'Position',[150 260 80 20],...
  'CallBack',[...
     'btfile = get(en_btfile,''String'');,',...
     'if exist(btfile)~=2 msgbox(''File not found.  Please reenter.'',''Error'',''Error''); end;']);

%*****Misc Lon/Lat file*****
cb_misc = uicontrol(f1,...
  'Style','checkbox',...
  'Fontsize',guifontsize,....
  'String','Plot ASCII Lon/Lat file:',...
  'Position',[20 235 140 20],...
  'Value',miscchoice,...
  'CallBack',[...
    'miscchoice = 1;,',...
    'if get(cb_misc,''Value'')==0,',...
      'miscchoice = 0;,',...
    'end']);
en_misclatlon = uicontrol(f1,...
  'Style','edit',...
  'Fontsize',guifontsize,....
  'String',miscfile,...
  'Position',[160 235 70 20],...
  'CallBack',[...
     'miscfile = get(en_misclatlon,''String'');,',...
     'if exist(miscfile)~=2 msgbox(''File not found.  Please reenter.'',''Error'',''Error''); end;']);

%*****Plot cruisetrack button*****
pb_plot = uicontrol(f1,...  
  'Style','push',...
  'Fontsize',guifontsize,....
  'String','Quick plot coast/bathy/misc',...
  'Pos',[50 210 150 20],...
  'CallBack',['ctchoice=0;','cl_ctplot;']);

%*****Cruisebuilder options*****
frame_cruisebuilder = uicontrol(f1,...
  'Style','frame',...
  'Position',[10 10 230 185]);
text_cruisebuilder = uicontrol(f1,...
  'Style','text',...
  'Fontsize',guifontsize,....
  'String','Cruisebuilder',...
  'HorizontalAlignment','Left',...
  'Position',[20 165 150 20]);
pb_cbhelp = uicontrol(f1,...
  'Style','push',...
  'Fontsize',guifontsize,....
  'String','Help',...
  'Pos',[190 170 40 20],...
  'CallBack','cl_ctcbhelp');

%*****NavMethod*****
text_ttmode = uicontrol(f1,...
  'Style','text',...
  'Fontsize',guifontsize,....
  'String','Nav method:',...
  'HorizontalAlignment','Left',...
  'Position',[20 140 100 20]);
rb_nmmode1 = uicontrol(f1,...
  'Style','radio',...
  'Fontsize',guifontsize,....
  'String','Rhumb Line',...
  'Position',[75 145 140 20],...
  'Value',rb_nmmode1,...
  'CallBack',[...
    'set(rb_nmmode1,''Value'',1),',...
    'set(rb_nmmode2,''Value'',0),',...
    'nmmode = 1;']);
rb_nmmode2 = uicontrol(f1,...
  'Style','radio',...
  'Fontsize',guifontsize,....
  'String','Great Circle',...
  'Position',[150 145 140 20],...
  'Value',rb_nmmode2,...
  'CallBack',[...
    'set(rb_nmmode1,''Value'',0),',...
    'set(rb_nmmode2,''Value'',1),',...
    'nmmode = 2;']);

%*****CBMode*****
cb_confirm = uicontrol(f1,...
  'Style','checkbox',...
  'Fontsize',guifontsize,....
  'String','Manually confirm lat/lon choices',...
  'Position',[20 123 180 20],...
  'Value',latlonconfirm,...
  'CallBack',[...
    'latlonconfirm = 1;,',...
    'if get(cb_confirm,''Value'')==0,',...
      'latlonconfirm = 0;,',...
    'end']);
text_cbmode2 = uicontrol(f1,...
  'Style','text',...
  'Fontsize',guifontsize,....
  'String','Default fixed spacing (km) along lines',...
  'HorizontalAlignment','Left',...
  'Position',[20 100 175 20]);
en_kmspacing = uicontrol(f1,...
  'Style','edit',...
  'Fontsize',guifontsize,....
  'String',num2str(kmspacing),...
  'Position',[200 100 30 20],...
  'CallBack','kmspacing = str2num(get(en_kmspacing,''String''));');
text_cbmode3 = uicontrol(f1,...
  'Style','text',...
  'Fontsize',guifontsize,....
  'String','Default fixed depth spacing (m) along lines',...
  'HorizontalAlignment','Left',...
  'Position',[20 80 210 20]);
text_depthspacing = uicontrol(f1,...
  'Style','text',...
  'Fontsize',guifontsize,....
  'String','Depth (m):  ',...
  'HorizontalAlignment','Center',...
  'Position',[20 55 70 20]);  
en_depthspacing = uicontrol(f1,...
  'Style','edit',...
  'Fontsize',guifontsize,....
  'String',num2str(depthspacing),...
  'Position',[80 60 30 20],...
  'CallBack','depthspacing = str2num(get(en_depthspacing,''String''));');
text_maxkmspacing = uicontrol(f1,...
  'Style','text',...
  'Fontsize',guifontsize,....
  'String','Max horiz (km):  ',...
  'HorizontalAlignment','Center',...
  'Position',[120 55 85 20]);  
en_maxkmspacing = uicontrol(f1,...
  'Style','edit',...
  'Fontsize',guifontsize,....
  'String',num2str(maxkmspacing),...
  'Position',[200 60 30 20],...
  'CallBack','maxkmspacing = str2num(get(en_maxkmspacing,''String''));');

%*****Start picking!*****
cb_startpicking = uicontrol(f1,...
  'Style','push',...
  'Fontsize',guifontsize,....
  'String','Start picking',...
  'Pos',[20 30 100 20],...
  'CallBack',['cl_ctcb;']);

%*****Update cruisetrack*****
pb_updatecruisetrack = uicontrol(f1,...
  'Style','push',...
  'Fontsize',guifontsize,....
  'String','Update cruisetrack',...
  'Pos',[130 30 100 20],...
  'CallBack',['cl_ctupd;']);


%*****Cruisetrack options*****
frame_inputfil = uicontrol(f1,...
  'Style','frame',...
  'Position',[250 10 230 405]);
text_cruiseoptions = uicontrol(f1,...
  'Style','text',...
  'Fontsize',guifontsize,....
  'String','Cruisetrack time options',...
  'HorizontalAlignment','Left',...
  'Position',[260 385 150 20]);
pb_cthelp = uicontrol(f1,...
  'Style','push',...
  'Fontsize',guifontsize,....
  'String','Help',...
  'Pos',[430 390 40 20],...
  'CallBack','cl_cthelp');

%*****Start date*****
text_startdate = uicontrol(f1,...
  'Style','text',...
  'Fontsize',guifontsize,....
  'String','Start date - Year:',...
  'HorizontalAlignment','Center',...
  'Position',[260 360 120 20]);
en_year = uicontrol(f1,...
  'Style','edit',...
  'Fontsize',guifontsize,....
  'String',num2str(startyear),...
  'Position',[390 365 80 20],...
  'CallBack','startyear = str2num(get(en_year,''String''));');
text_startmonth = uicontrol(f1,...
  'Style','text',...
  'Fontsize',guifontsize,....
  'String','Month',...
  'HorizontalAlignment','Center',...
  'Position',[260 335 40 20]);
en_month = uicontrol(f1,...
  'Style','edit',...
  'Fontsize',guifontsize,....
  'String',num2str(startmonth),...
  'Position',[300 340 30 20],...
  'CallBack','startmonth = str2num(get(en_month,''String''));');
text_startday = uicontrol(f1,...
  'Style','text',...
  'Fontsize',guifontsize,....
  'String','Day',...
  'HorizontalAlignment','Center',...
  'Position',[330 335 40 20]);
en_day = uicontrol(f1,...
  'Style','edit',...
  'Fontsize',guifontsize,....
  'String',num2str(startday),...
  'Position',[370 340 30 20],...
  'CallBack','startday = str2num(get(en_day,''String''));');
text_starthour = uicontrol(f1,...
  'Style','text',...
  'Fontsize',guifontsize,....
  'String','Hour',...
  'HorizontalAlignment','Center',...
  'Position',[400 335 40 20]);
en_hour = uicontrol(f1,...
  'Style','edit',...
  'Fontsize',guifontsize,....
  'String',num2str(starthour),...
  'Position',[440 340 30 20],...
  'CallBack','starthour = str2num(get(en_hour,''String''));');

%*****Input file*****
text_inputfil = uicontrol(f1,...
  'Style','text',...
  'Fontsize',guifontsize,....
  'String','Waypoint file prefix:',...
  'HorizontalAlignment','Center',...
  'Position',[260 310 120 20]);
en_inputfil = uicontrol(f1,...
  'Style','edit',...
  'Fontsize',guifontsize,....
  'String',inputfile,...
  'Position',[390 315 80 20],...
  'CallBack','inputfile = get(en_inputfil,''String'');');

%*****Number of sections*****
text_numsec = uicontrol(f1,...
  'Style','text',...
  'Fontsize',guifontsize,....
  'String','Number of sections:',...
  'HorizontalAlignment','Center',...
  'Position',[260 285 120 20]);
en_numsec = uicontrol(f1,...
  'Style','edit',...
  'Fontsize',guifontsize,....
  'Pos',[390 290 80 20],...
  'String',num2str(numsec),...
  'CallBack',[...
    'numsec = str2num(get(en_numsec,''String''));,',...
    ]);

%*****Trackfile1*****
text_trackfile1 = uicontrol(f1,...
  'Style','text',...
  'Fontsize',guifontsize,....
  'String','Trackfile to start of grid:',...
  'HorizontalAlignment','Center',...
  'Position',[260 260 120 20]);
en_trackfile1 = uicontrol(f1,...
  'Style','edit',...
  'Fontsize',guifontsize,....
  'String',trackfile1,...
  'Position',[390 265 80 20],...
  'CallBack',[...
     'trackfile1 = get(en_trackfile1,''String'');,',...
     'if isempty(trackfile1)==0 & exist(trackfile1)~=2 msgbox(''File not found.  Please reenter.'',''Error'',''Error''); end;']);

%*****Trackfile2*****
text_trackfile2 = uicontrol(f1,...
  'Style','text',...
  'Fontsize',guifontsize,....
  'String','Trackfile fm end of grid:',...
  'HorizontalAlignment','Center',...
  'Position',[260 235 120 20]);
en_trackfile2 = uicontrol(f1,...
  'Style','edit',...
  'Fontsize',guifontsize,....
  'String',trackfile2,...
  'Position',[390 240 80 20],...
  'CallBack',[...
     'trackfile2 = get(en_trackfile2,''String'');,',...
     'if isempty(trackfile2)==0 & exist(trackfile2)~=2 msgbox(''File not found.  Please reenter.'',''Error'',''Error''); end;']);

%*****Speed while doing sections*****
text_speedsec = uicontrol(f1,...
  'Style','text',...
  'Fontsize',guifontsize,....
  'String','Speed (kts) taking data:',...
  'HorizontalAlignment','Center',...
  'Position',[260 210 120 20]);
en_speedsec = uicontrol(f1,...
  'Style','edit',...
  'Fontsize',guifontsize,....
  'Pos',[390 215 80 20],...
  'String',num2str(speedsec),...
  'CallBack',[...
    'speedsec = str2num(get(en_speedsec,''String''));,',...
    ]);

%*****Speed while transiting*****
text_speedtransit = uicontrol(f1,...
  'Style','text',...
  'Fontsize',guifontsize,....
  'String','Speed (kts) transiting:',...
  'HorizontalAlignment','Center',...
  'Position',[260 187 120 20]);
en_speedtransit = uicontrol(f1,...
  'Style','edit',...
  'Fontsize',guifontsize,....
  'Pos',[390 190 80 20],...
  'String',num2str(speedtransit),...
  'CallBack',[...
    'speedtransit = str2num(get(en_speedtransit,''String''));,',...
    ]);

%*****Wire rate*****
text_wire = uicontrol(f1,...
  'Style','text',...
  'Fontsize',guifontsize,....
  'String','Cast time - minutes RT',...
  'HorizontalAlignment','Center',...
  'Position',[260 170 120 20]);
text_wire = uicontrol(f1,...
  'Style','text',...
  'Fontsize',guifontsize,....
  'String','per 1000m of depth:',...
  'HorizontalAlignment','Center',...
  'Position',[260 155 120 20]);
en_wire = uicontrol(f1,...
  'Style','edit',...
  'Fontsize',guifontsize,....
  'Pos',[390 165 80 20],...
  'String',num2str(wiretime),...
  'CallBack',[...
    'wiretime = str2num(get(en_wire,''String''));,',...
    ]);

%*****Number of fudges*****
text_numfudge = uicontrol(f1,...
  'Style','text',...
  'Fontsize',guifontsize,....
  'String','Number of misc events:',...
  'HorizontalAlignment','Center',...
  'Position',[260 135 120 20]);
en_numfudge = uicontrol(f1,...
  'Style','edit',...
  'Fontsize',guifontsize,....
  'Pos',[390 140 80 20],...
  'String',num2str(numfudge),...
  'CallBack',[...
    'numfudge = str2num(get(en_numfudge,''String''));,',...
    ]);

%*****Duration of fudges*****
text_durfudge1 = uicontrol(f1,...
  'Style','text',...
  'Fontsize',guifontsize,....
  'String','Duration (hrs) each:',...
  'HorizontalAlignment','Center',...
  'Position',[255 110 120 20]);
en_durfudge = uicontrol(f1,...
  'Style','edit',...
  'Fontsize',guifontsize,....
  'Pos',[390 115 80 20],...
  'String',num2str(durfudge),...
  'CallBack',[...
    'durfudge = str2num(get(en_durfudge,''String''));,',...
    ]);

%*****Weather days*****
text_weather = uicontrol(f1,...
  'Style','text',...
  'Fontsize',guifontsize,....
  'String','Weather days (1 f/each X):',...
  'HorizontalAlignment','Center',...
  'Position',[255 85 130 20]);
en_weather = uicontrol(f1,...
  'Style','edit',...
  'Fontsize',guifontsize,....
  'Pos',[390 90 80 20],...
  'String',num2str(weather),...
  'CallBack',[...
    'weather = str2num(get(en_weather,''String''));,',...
    ]);

%*****Save outfile?*****
cb_saveout = uicontrol(f1,...
  'Style','checkbox',...
  'Fontsize',guifontsize,...
  'String','Save cruisetrack output to ASCII file',...
  'Position',[260 60 210 20],...
  'Value',saveoutchoice,...
  'CallBack',[...
    'saveoutchoice = 0;,',...
    'if get(cb_saveout,''Value'')==1,',...
      'saveoutchoice = 1;,',...
    'end']);

%*****Compute time button*****
pb_loadcomp = uicontrol(f1,...
  'Style','push',...
  'Fontsize',guifontsize,...
  'String','Compute time',...
  'Pos',[260 30 100 20],...
  'CallBack',['daybox=1;','cl_ctloadcomp;']);

%*****Cruisetrack plot button*****
pb_cruisetrackplot = uicontrol(f1,...
  'Style','push',...
  'Fontsize',guifontsize,...
  'String','Plot track',...
  'Pos',[370 30 100 20],...
  'CallBack',['daybox=0;','ctchoice=1;','cl_ctplot;']);