% cl_ctcbplots.m
%
% Cruisebuilder plotting code
% 
% Usage: cl_ct
% Click on help buttons for tips.
% Version 1.7, 11 June 2008, Chris Linder
%

% This is the start of the actual plotting...
eval(sprintf('figure(f%d);',cbruns));

title('Plotting coastline...');
% Coastline plotting
if(clchoice)
  if exist('m_gshhs_l')==0
    msgbox('Note!  gshhs coastlines not found - using m_coast','Note','warn');
    m_coast('patch',[.5 .5 .5]); 
  else
    if fn > 50
      m_gshhs_c('patch',[.5 .5 .5]);
    elseif fn > 11
      m_gshhs_l('patch',[.5 .5 .5]);
    elseif fn > 1
      m_gshhs_i('patch',[.5 .5 .5]);
    else
      m_gshhs_h('patch',[.5 .5 .5]);
    end;
  end;
end;

% Bathymetry plotting
if(btchoice)
  if size(btcontours,2)==1 btcontours=[btcontours btcontours]; end;
  [c,h]=m_contour(LON,LAT,data,btcontours,'k');
  if isempty(c) == 0
     clabel(c,h);
  end;
end;

% Misc Lon/Lat file plotting
if(miscchoice)
  if exist(miscfile)==2
    title('Plotting lat/lon file...');
    eval(sprintf('figure(f%d);',cbruns));
    eval(sprintf('iedata=load(''%s'');',miscfile));
    % This assumes we have a 2 column ASCII file of (1) lats (2) lons to plot
    lats=iedata(:,2);
    lons=iedata(:,1);
    m_plot(lons,lats,'m');
    hold on;
    m_plot(lons,lats,'m.');
    hold on;
  end; % miscgoodflag
end; % Misc Lon/Lat file plotting

m_grid('box','fancy'); 
set(findobj('tag','m_grid_color'),'facecolor','none');

% Add in any other points/lines you wish to appear on your plot:
